<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use App\Http\Providers\iam\core\model\OracleOCIConnector;
use Carbon\Carbon;
use Illuminate\Database\Capsule\Manager;
use Illuminate\Support\Facades\DB;

class PopenerimaanioModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "popenerimaanio";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "popenerimaanio";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "ioNumber", "kapalId", "date", "status", "operatingUnit", "quantity", "qtyReceiptNumber", "date_updated", "vendorId", "vendorName", "fromKapalId"

    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "ioNumber" => "popenerimaanio.ioNumber",
        "status" => "popenerimaanio.status",
        "kapalId" => "popenerimaanio.kapalId",
        "date" => "popenerimaanio.date",
        /* "voyageKode" => "penerimaanBarangIoId.voyageKode",
        "voyageStart" => "penerimaanBarangIoId.voyageStart",
        "voyageEnd" => "penerimaanBarangIoId.voyageEnd", */
        "voyageName" => "voyages.voyageName"
    ];

    /**
     * relation from ' . itempopenerimaanio . ' by ' . penerimaanBarangId
     * join itempopenerimaanio on itempopenerimaanio.ioNumber = popenerimaanio.penerimaanBarangId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationItemPoPenerimaanIoBarangId($alias = "itempopenerimaanio")
    {
        $this->getQuery()   ->join("itempopenerimaanio as $alias","$alias.ioNumber", "=", "popenerimaanio.ioNumber")
            ->join("item as itemId", "itemId.id", "=", "$alias.itemId");
        return $this;
    }


    public function joinRelationPenerimaanBarangIoId($alias = "penerimaanBarangIoId")
    {
        $this->getQuery()->leftjoin("penerimaanbarangio as $alias", "$alias.ioNumber", "=", "popenerimaanio.ioNumber");
        return $this;
    }


    public function joinRelationKapalId($alias = "kapalId")
    {
        $this->getQuery()->join("kapal as $alias", "$alias.id", "=", "popenerimaanio.kapalId");
        return $this;
    }

    // SYNC ERROR MULAI DARI SINI
    public function syncErrorFromOracleHO($ioNumber, $kapalID, $fromKapalID, $fromCMS = false)
    {
        echo "start sync recovery Penerimaan IO data from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Sync Recovery Penerimaan IO", Carbon::now()->toDateTimeString(), "", "start");
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getSyncErrorOracleQuery($ioNumber, $kapalID, $fromKapalID))->execute();
        $rows = $oracleOCI->fetchAll();  $return = false;
        if($rows) {
            $item = new self();
            $return = $item->storingDataFromOracle($rows, $fromCMS);
        } else {
            $return = false;
        }
        (new LogsyncoracleModel)->setLogSync("Sync Recovery Penerimaan IO", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
        return $return;
    }

    public function syncFromOracleHO($syncTable, $fromCMS = false)
    {
        echo "start sync po penerimaan io data from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan IO", Carbon::now()->toDateTimeString(), "", "start");
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getOracleQuery($syncTable, 0, 0))->execute();
        $lastUpdate = $syncTable->last_sync;
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows, $fromCMS);
            if (!empty($rows->LAST_UPDATE_DATE)) $lastUpdate = $rows->LAST_UPDATE_DATE;
            $syncTable = \App\Http\Models\SyncUtilities\StagingSyncTableModel::find($syncTable->id);
            $syncTable->last_sync = $lastUpdate;
            $syncTable->update();
        }
        (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan IO", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
    }

    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        /* $query = "SELECT
        IOV.SHIPMENT_NUMBER,
        IOV.TO_ORG_ID,
        IOV.DATE_INTRANSIT,
        IOV.FROM_ORG_CODE,
        IOV.LAST_UPDATE_DATE,
        IOV.FROM_ORG_ID,
        SUM(IOV.QTY) AS QTY
      FROM pelni_iot_v IOV
WHERE
 IOV.LAST_UPDATE_DATE >= TO_DATE('" . Carbon::parse($staging->last_sync) . "', 'yyyy-mm-dd HH24:MI:SS')
 GROUP By SHIPMENT_NUMBER, TO_ORG_ID, DATE_INTRANSIT, FROM_ORG_CODE, LAST_UPDATE_DATE, FROM_ORG_ID
  ORDER BY IOV.LAST_UPDATE_DATE ASC"; */
        $query = "  SELECT
                        IOV.SHIPMENT_NUMBER,
                        IOV.TO_ORG_ID,
                        TO_CHAR(IOV.DATE_INTRANSIT, 'yyyy-mm-dd') AS DATE_INTRANSIT,
                        IOV.FROM_ORG_CODE,
                        TO_CHAR(IOV.LAST_UPDATE_DATE, 'yyyy-mm-dd') AS LAST_UPDATE_DATE,
                        IOV.FROM_ORG_ID,
                        SUM(IOV.QTY) AS QTY,
                        COUNT(IOV.SHIPMENT_NUMBER) AS TOTAL_LINE
                    FROM pelni_iot_v IOV
                    WHERE IOV.LAST_UPDATE_DATE >= TO_DATE('" . Carbon::parse($staging->last_sync) . "', 'yyyy-mm-dd HH24:MI:SS')
                    GROUP BY SHIPMENT_NUMBER, TO_ORG_ID, TO_CHAR(IOV.DATE_INTRANSIT, 'yyyy-mm-dd'), FROM_ORG_CODE, TO_CHAR(IOV.LAST_UPDATE_DATE, 'yyyy-mm-dd'), FROM_ORG_ID
                    ORDER BY TO_CHAR(IOV.LAST_UPDATE_DATE, 'yyyy-mm-dd')";
        return $query;
    }

    public static function getSyncErrorOracleQuery($ioNumber, $kapalID, $fromKapalID)
    {
        $query = "  SELECT
                        IOV.SHIPMENT_NUMBER,
                        IOV.TO_ORG_ID,
                        TO_CHAR(IOV.DATE_INTRANSIT, 'yyyy-mm-dd') AS DATE_INTRANSIT,
                        IOV.FROM_ORG_CODE,
                        TO_CHAR(IOV.LAST_UPDATE_DATE, 'yyyy-mm-dd') AS LAST_UPDATE_DATE,
                        IOV.FROM_ORG_ID,
                        SUM(IOV.QTY) AS QTY,
                        COUNT(IOV.SHIPMENT_NUMBER) AS TOTAL_LINE
                    FROM pelni_iot_v IOV
                    WHERE IOV.SHIPMENT_NUMBER = '" . $ioNumber . "' AND IOV.TO_ORG_ID = '" . $kapalID . "' AND IOV.FROM_ORG_ID = '" . $fromKapalID . "'
                    GROUP BY SHIPMENT_NUMBER, TO_ORG_ID, TO_CHAR(IOV.DATE_INTRANSIT, 'yyyy-mm-dd'), FROM_ORG_CODE, TO_CHAR(IOV.LAST_UPDATE_DATE, 'yyyy-mm-dd'), FROM_ORG_ID
                    ORDER BY TO_CHAR(IOV.LAST_UPDATE_DATE, 'yyyy-mm-dd')";
        return $query;
    }


    public function mapperOracle($oracle)
    {
        $this->ioNumber = $oracle->SHIPMENT_NUMBER;
        $this->kapalId = $oracle->TO_ORG_ID;
        $this->operatingUnit = $oracle->FROM_ORG_CODE;
        $this->date = $oracle->DATE_INTRANSIT;
        $this->date_updated = $oracle->LAST_UPDATE_DATE;
        $this->quantity = $oracle->QTY;
        $this->fromKapalId = $oracle->FROM_ORG_ID;
        $this->status = 0;
    }

    public function storingDataFromOracle($oracle, $fromCMS = false)
    {
        $modelExist = (new self())->getQuery()->where("popenerimaanio.ioNumber", "=", $oracle->SHIPMENT_NUMBER)
            ->where("popenerimaanio.kapalId", "=", $oracle->TO_ORG_ID)
            ->where("popenerimaanio.operatingUnit", "=", $oracle->FROM_ORG_CODE)
            ->first();

        if($fromCMS) { DB::beginTransaction(); } else { Manager::beginTransaction(); }
        if (! $modelExist) {
            try {
                $model = new self();
                $model->mapperOracle($oracle);
                $model->save();
                (new ItempopenerimaanioModel())->syncItemFromOracleHO($oracle->SHIPMENT_NUMBER);
                if($fromCMS) { DB::commit(); } else { Manager::commit(); }
                echo $model->ioNumber . " inserted ", PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Penerimaan IO : " . $model->ioNumber, Carbon::now()->toDateTimeString(), "", "inserted");
                return true;
            } catch (\Exception $exception) {
                if($fromCMS) { DB::rollBack(); } else { Manager::rollBack(); }
                $params = json_encode([
                    "SHIPMENT_NUMBER" => $oracle->SHIPMENT_NUMBER,
                    "TO_ORG_ID" => $oracle->TO_ORG_ID,
                    "FROM_ORG_ID" => $oracle->FROM_ORG_ID
                ]);
                $data = json_encode($oracle);
                (new SyncerrorModel)->saveError("pelni_iot_v", $params, $data, "HO");

                 echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Penerimaan IO : " . $model->ioNumber, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        }else {
            $model = self::find($modelExist->id);
            $model->kapalId = $oracle->TO_ORG_ID;
            $model->operatingUnit = $oracle->FROM_ORG_CODE;
            $model->date = $oracle->DATE_INTRANSIT;
            $model->date_updated = $oracle->LAST_UPDATE_DATE;
            $model->quantity = $oracle->QTY;
            $model->fromKapalId = $oracle->FROM_ORG_ID;
            try {
                $model->update();
                (new ItempopenerimaanioModel())->syncItemFromOracleHO($oracle->SHIPMENT_NUMBER);
                if($fromCMS) { DB::commit(); } else { Manager::commit(); }
                echo $model->ioNumber . " " . $this->getTable() . " updated ", PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan PO : ".$model->ioNumber, Carbon::now()->toDateTimeString(), "", "updated");
                return true;
            } catch (\Exception $exception) {
                if($fromCMS) { DB::rollBack(); } else { Manager::rollBack(); }
                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan PO : ".$model->ioNumber, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        }
    }

    public static function storeFromHO($data, $fromCMS = false)
    {
        $modelExist = (new self())->getQuery()->where("popenerimaanio.ioNumber", "=", $data->ioNumber)
            ->where("popenerimaanio.kapalId", "=", $data->kapalId)
            ->where("popenerimaanio.operatingUnit", "=", $data->operatingUnit)
            ->first();
        if (!$modelExist) {
            //insert Here
            if($fromCMS) { DB::beginTransaction(); } else { Manager::beginTransaction(); }
            try {
                $model = new self((array) $data);
                $model->save([], $data->id, 0);
                (new LogsynckapalModel)->setLogSync("PO Penerimaan IO : ".$data->ioNumber, Carbon::now()->toDateTimeString(), "", " inserted");
                if (!empty($data->detail)) {
                    foreach ($data->detail as $detail) {
                        $detailPo = new ItempopenerimaanioModel();
                        $detailPo->fill((array) $detail);
                        $detailPo->save([], $detail->id, 0);
                        (new LogsynckapalModel)->setLogSync("Penerimaan IO Detail : ".$data->ioNumber. " - ".$detail->itemId, Carbon::now()->toDateTimeString(), "", " inserted");
                    }
                }
                if($fromCMS) { DB::commit(); } else { Manager::commit(); }
                return true;
            } catch (\Exception $exception) {
                if($fromCMS) { DB::rollBack(); } else { Manager::rollBack(); }

                $params = json_encode([
                    "ioNumber" => $data->ioNumber,
                    "kapalId" => $data->kapalId,
                    "fromKapalId" => $data->fromKapalId
                ] );
                (new SyncerrorModel)->saveError("popenerimaanio", $params, json_encode($data), "KAPAL");

                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan IO : ".$data->ioNumber, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        }
        //Update Here
        else{
            $model = self::find($modelExist->id);
            $model->kapalId = $data->kapalId;
            $model->date = $data->date;
            $model->operatingUnit = $data->operatingUnit;
            $model->date_updated = $data->date_updated;
            $model->quantity = $data->quantity;
            $model->fromKapalId = $data->fromKapalId;
            $model->update();
            (new LogsynckapalModel)->setLogSync("PO Penerimaan IO - ".$data->ioNumber, Carbon::now()->toDateTimeString(), "", " updated");

            //update PO Detail here, in case any update data from oracle
            if (!empty($data->detail)) {
                foreach ($data->detail as $detail) {
                    echo " data " . $detail->itemId ." | ". $detail->ioNumber;
                    $detailPo = (new ItempopenerimaanioModel())->getQuery()->where("itempopenerimaanio.ioNumber", "=", $detail->ioNumber)
                        ->where("itempopenerimaanio.itemId", "=", $detail->itemId)
                        ->where("itempopenerimaanio.lotNumber", "=", $detail->lotNumber)
                        ->first();
                    if ($detailPo) {
                        $model = new ItempopenerimaanioModel();
                        $model = $model::find($detailPo->id);
                        $model->itemId = $detail->itemId;
                        $model->quantity = $detail->quantity;
                        // $model->qtyRemaining = $detail->qtyRemaining;
                        $model->lokasiId = $detail->lokasiId;
                        $model->fromLokasiId =  $detail->fromLokasiId;
                        $model->lotNumber =  $detail->lotNumber;
                        $model->date_updated = $detail->date_updated;
                        $model->update();
                        (new LogsynckapalModel)->setLogSync("Penerimaan IO Detail - ".$detail->ioNumber." - ".$detail->itemId , Carbon::now()->toDateTimeString(), "", " updated");
                    }
                    else{
                        $model = new ItempopenerimaanioModel();
                        $model->fill((array)$detail);
                        $model->save([], $detail->id, 0);
                        (new LogsynckapalModel)->setLogSync("Penerimaan IO Detail - ".$detail->ioNumber." - ".$detail->itemId , Carbon::now()->toDateTimeString(), "", " inserted");
                    }
                }
            }
            return true;
        }

    }

    public static function getPOIO($fromCMS = false)
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_po_io";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 9)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("PO Penerimaan IO HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {

                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $url = $url . "?date_updated=" . $lastUpdate . "&kapalId=" . $GLOBALS["env"]["KAPAL_ID"] . "&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)){
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\PopenerimaanioModel::storeFromHO($item, $fromCMS);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    }
                    else $fetch = false;

                } catch (Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("PO Penerimaan IO HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("PO Penerimaan IO HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }


}
